<template>
    
    <v-form lazy-validation v-model="valid">
        <v-container>
        <v-text-field label="Roomname" v-model="room.name" :rules="nameRules" required/>
        <v-textarea label="Description" v-model="room.description"
        hint="Here you can write a brief description about your room."/>
        <v-divider/>
        <h2 class="text-center">
            Default values
        </h2>
        <v-card-title class="justify-center text-center">The values that you choose here will be assigned to the home automation elements when there is no timeslot assigned for the particular element.<br> Leave the input values empty if you don't want to define a default value.</v-card-title>
        <v-row justify="center">
            <v-col cols="12" sm="12" md="6" lg="6" xl="3"><v-text-field v-model="temperature" v-on:change="changeTemperature" :rules="temperatureRules" label="Default temperature" hint="Choose a desired temperature between 0 and 30. 0 to have the heating turned off." type="number" suffix="°C"/>
        </v-col>
        <v-col cols="12" sm="12" md="6" lg="6" xl="3" ><v-text-field v-model="lights" v-on:change="changeLights" :rules="lightRules" label="Default light intensity" type="number" hint="Choose a desired light intensity between 0 and 20. 0 to have the light turned off."/>
        </v-col>
        <v-col cols="12" sm="12" md="6" lg="6" xl="3" ><v-text-field v-model="volume" v-on:change="changeVolume" :rules="volumeRules" label="Default volume" type="number" hint="Choose a desired volume between 0 and 20. 0 to have the music turned off."/>
        </v-col>
        <v-col cols="12" sm="12" md="6" lg="6" xl="3" ><v-select v-model="curtains" v-on:change="changeCurtains" :items="options" label="Curtains default state"></v-select>
        </v-col>
        </v-row>
        <v-row justify="center">
            <v-btn color="primary" :disabled="!valid" @click="$emit('save-changes-click',room);">Save changes to room</v-btn>
        </v-row>
        </v-container>
    </v-form>   
</template>
<script>
export default {
    name: "RoomForm",
    props: {
        room: {
            type: Object,
            required:false
        }
    },
    data: () => ({
        options:['Open','Closed'],
        timeslots:Array,
        valid: true,        
        selectedCurtain: null,
        nameRules:[v=>!!v || 'Name is required'],
        temperatureRules:[v=>v>=0&&v<=30 || 'The temperature cannot be below 0 or above 30'],
        lightRules:[v=>v>=0&&v<=20 || 'The light intensity cannot be below 0 or above 20'],
        volumeRules:[v=>v>=0&&v<=20 || 'The volume cannot be below 0 or above 20'],
        temperature:null,
        lights:null,
        volume:null,
        curtains:null
    }),
    watch: {
        room(){
            this.loadDefaults()
        }
    },
    methods:{
        loadDefaults(){
            if(this.room.temperature.default){
               this.temperature = this.room.temperature.default
            }
            if(this.room.lights.default){
               this.lights = this.room.lights.default
            }
            if(this.room.volume.default){
               this.volume = this.room.volume.default
            }
            if(this.room.curtains.default==false){
               this.curtains = "Open"
            }else if(this.room.curtains.default==true){
               this.curtains = "Closed"
            }
            
        },
        changeLights(){
            this.room.lights.default = this.lights
        },
        changeTemperature(){
            this.room.temperature.default = this.temperature
        },
        changeVolume(){
            this.room.volume.default = this.volume
        },
        changeCurtains(){
            if(this.curtains=='Open'){
                this.room.curtains.default = false;
            }else if(this.curtains=='Closed'){
                this.room.curtains.default = true;
            }
        }
    }
}
</script>